#define FALSE 0
#define TRUE 1

#define NONE	0
#define ODD	1
#define EVEN	2
#define MARK	3
#define SPACE	4

#define UPROM		0
#define UPROM2001	1
#define BOOTLOADER	2

#define DUMP_WIDTH	8

#define BEL	7
#define TAB	9
#define LF	10
#define FF	12
#define CR	13
#define ESC	27

#define BYTE unsigned char

int verbosity;
#define VB_ERR	0		/* write to konsole and log file */
#define VB_INFO	1
#define VB_DBG	3
#define LOG_ERR	 0x1000		/* write to log file only */
#define LOG_INFO 0x1001
#define LOG_DBG  0x1003

long Baud_Rate;
int Data_Bits;
int Stop_Bits;
int Parity;		/* 0=NONE, 1=Odd, 2=Even, 3=Mark, 4=Space */
int Hardware_Handshake;
long delay_serial;

/* 
  Size of prommer's internal buffer = packet size on programming,
  must not exceed 0x1000 for u-prom 
  must not exceed 0x1770 for u-prom 2001
*/
#define PROMBUFSIZE 256
#define BUFSIZE 1048592	/* 1 MB + 16 bytes*/
BYTE *buffer; 

int ictyp, mc, dc, nr;
long from, size, offset, erraddr;

enum {
  CMD_READ_COPY, 
  CMD_READ_MASTER, 
  CMD_BLANK_COPY, 
  CMD_COPY_EQU_MASTER, 
  CMD_PRG_COPY,
  CMD_GET_ID,
  CMD_ERASE 
};

struct hml { BYTE h; BYTE m; BYTE l; };
typedef struct hml HML;

int fd;
char devicename[80];
long Baud_Rate;

struct termios sio;
long BAUD;
long DATABITS;
long STOPBITS;
long PARITYON;
long PARITY;

char errmsg[23][32];

/* Prototypes */
int open_port(int send_break);
int close_port(int send_break);
void dump_args(void);
void lvprintf(int v, const char *fmt, ...);
int statln(long int pos, long int total);
int endstatln(long from, long total);
void long2hml(long v, HML *byte);
long hml2long(HML *bytes);
void errhdl(int errcde);
void show_buffer(long from, long size);
int calc_crc(long from, long size);
void show_cmdbuffer(char *cmdbuffer, int size);
int send_cmdbuffer(char *cmdbuffer, int size);
int save_buffer(long size, long offset, char *filename);
int load_buffer(long size, long offset, char *filename);
