/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define CMDLINE_PARSER_PACKAGE "bprom"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "0.3.2"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *full_help_help; /**< @brief Print help, including hidden options, and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  const char *verbose_help; /**< @brief Let you know what happens, be more verbose help description.  */
  const char *debug_help; /**< @brief Very verbose output for debugging help description.  */
  char * programmer_arg;	/**< @brief What programmer is used (default='uprom2001').  */
  char * programmer_orig;	/**< @brief What programmer is used original value given at command line.  */
  const char *programmer_help; /**< @brief What programmer is used help description.  */
  char * serial_port_arg;	/**< @brief  (default='/dev/tty.usbserial').  */
  char * serial_port_orig;	/**< @brief  original value given at command line.  */
  const char *serial_port_help; /**< @brief  help description.  */
  char * baud_rate_arg;	/**< @brief  (default='38400').  */
  char * baud_rate_orig;	/**< @brief  original value given at command line.  */
  const char *baud_rate_help; /**< @brief  help description.  */
  int no_handshake_flag;	/**< @brief RTS/CTS is used by default (default=off).  */
  const char *no_handshake_help; /**< @brief RTS/CTS is used by default help description.  */
  long delay_arg;	/**< @brief Pause serial transmission for given nanoseconds between each byte (default='0').  */
  char * delay_orig;	/**< @brief Pause serial transmission for given nanoseconds between each byte original value given at command line.  */
  const char *delay_help; /**< @brief Pause serial transmission for given nanoseconds between each byte help description.  */
  char * read_arg;	/**< @brief Read chip and write data to file.  */
  char * read_orig;	/**< @brief Read chip and write data to file original value given at command line.  */
  const char *read_help; /**< @brief Read chip and write data to file help description.  */
  char * write_arg;	/**< @brief Write chip with data from file.  */
  char * write_orig;	/**< @brief Write chip with data from file original value given at command line.  */
  const char *write_help; /**< @brief Write chip with data from file help description.  */
  const char *blank_help; /**< @brief Perform blank test help description.  */
  const char *compare_help; /**< @brief Compare data from master socket with copy socket help description.  */
  const char *erase_help; /**< @brief Erase EEPROM help description.  */
  const char *master_socket_help; /**< @brief Use master socket instead of copy socket help description.  */
  const char *auto_help; /**< @brief Try to autodetect chip (MAY DESTROY CHIP!!!) help description.  */
  char * type_arg;	/**< @brief EPROM type (e.g. 2732A).  */
  char * type_orig;	/**< @brief EPROM type (e.g. 2732A) original value given at command line.  */
  const char *type_help; /**< @brief EPROM type (e.g. 2732A) help description.  */
  char * mode_arg;	/**< @brief mode: programming mode (fast/std) or chip type and programming mode defining byte (refer to table).  */
  char * mode_orig;	/**< @brief mode: programming mode (fast/std) or chip type and programming mode defining byte (refer to table) original value given at command line.  */
  const char *mode_help; /**< @brief mode: programming mode (fast/std) or chip type and programming mode defining byte (refer to table) help description.  */
  long from_arg;	/**< @brief Start address (EPROM).  */
  char * from_orig;	/**< @brief Start address (EPROM) original value given at command line.  */
  const char *from_help; /**< @brief Start address (EPROM) help description.  */
  long size_arg;	/**< @brief Number of bytes to be written or read.  */
  char * size_orig;	/**< @brief Number of bytes to be written or read original value given at command line.  */
  const char *size_help; /**< @brief Number of bytes to be written or read help description.  */
  long offset_arg;	/**< @brief Displacement for transfering a file to r/w buffer.  */
  char * offset_orig;	/**< @brief Displacement for transfering a file to r/w buffer original value given at command line.  */
  const char *offset_help; /**< @brief Displacement for transfering a file to r/w buffer help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int full_help_given ;	/**< @brief Whether full-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */
  unsigned int debug_given ;	/**< @brief Whether debug was given.  */
  unsigned int programmer_given ;	/**< @brief Whether programmer was given.  */
  unsigned int serial_port_given ;	/**< @brief Whether serial-port was given.  */
  unsigned int baud_rate_given ;	/**< @brief Whether baud-rate was given.  */
  unsigned int no_handshake_given ;	/**< @brief Whether no-handshake was given.  */
  unsigned int delay_given ;	/**< @brief Whether delay was given.  */
  unsigned int read_given ;	/**< @brief Whether read was given.  */
  unsigned int write_given ;	/**< @brief Whether write was given.  */
  unsigned int blank_given ;	/**< @brief Whether blank was given.  */
  unsigned int compare_given ;	/**< @brief Whether compare was given.  */
  unsigned int erase_given ;	/**< @brief Whether erase was given.  */
  unsigned int master_socket_given ;	/**< @brief Whether master-socket was given.  */
  unsigned int auto_given ;	/**< @brief Whether auto was given.  */
  unsigned int type_given ;	/**< @brief Whether type was given.  */
  unsigned int mode_given ;	/**< @brief Whether mode was given.  */
  unsigned int from_given ;	/**< @brief Whether from was given.  */
  unsigned int size_given ;	/**< @brief Whether size was given.  */
  unsigned int offset_given ;	/**< @brief Whether offset was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];
/** @brief all the lines making the full help output (including hidden options) */
extern const char *gengetopt_args_info_full_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the full help (including hidden options)
 */
void cmdline_parser_print_full_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);

extern char *cmdline_parser_programmer_values[] ;	/**< @brief Possible values for programmer.  */
extern char *cmdline_parser_baud_rate_values[] ;	/**< @brief Possible values for baud-rate.  */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
